Subject: Re: [PATCH net-next 7/7] ibmvnic: Perform tx CSO during send scrq direct

From: Jakub Kicinski <[email-masked]>
Date: Mon, 5 Aug 2024 12:09:59 -0700

On Mon, 5 Aug 2024 08:52:57 -0500 Nick Child wrote:
> On 8/2/24 19:15, Jakub Kicinski wrote:
> > On Thu,  1 Aug 2024 16:23:40 -0500 Nick Child wrote:  
> >> This extra
> >> precaution (requesting header info when the backing device may not use
> >> it) comes at the cost of performance (using direct vs indirect hcalls
> >> has a 30% delta in small packet RR transaction rate).  
> > 
> > What's "small" in this case? Non-GSO, or also less than MTU?  
> 
> I suppose "non-GSO" is the proper term. If a packet is non-GSO
> then we are able to use the direct hcall. On the other hand,
> if a packet is GSO then indirect must be used, we do not have the option 
> of direct vs indirect.

It'd be great to add more exact analysis to the commit message.
Presumably the change is most likely to cause trouble in combination
with large non-GSO frames. Could you measure the perf impact when TSO
is disabled and MTU is 9k?